=== src/CMakeLists.txt ===
# Axe library (libaxe.a)
FILE(GLOB DATRIE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/datrie/*.c)
FILE(GLOB GSL_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/gsl/*.c)
SET(AXELIB_SRCS ${DATRIE_SRCS} ${GSL_SRCS} axe.c)

ADD_LIBRARY(axelib STATIC ${AXELIB_SRCS})
TARGET_LINK_LIBRARIES(axelib qes_static)
SET_TARGET_PROPERTIES(axelib PROPERTIES OUTPUT_NAME axe)

# Executable
ADD_EXECUTABLE(axe main.c)
TARGET_LINK_LIBRARIES(axe ${AXE_DEPENDS_LIBS} axelib)
INSTALL(TARGETS axe DESTINATION "bin")
