=== debian/control ===
Source: axe-demuxer
Maintainer: Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9),
	       cmake,
               zlib1g-dev
Homepage: https://github.com/kdmurray91/axe

Package: axe-demuxer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Trie-based DNA sequencing read demultiplexer
 AXE very rapidly selects the optimal barcode present in a sequence read, even
 in the presence of sequencing errors. The algorithm is able to handle
 combinatorial barcoding, barcodes of differing length, and several mismatches
 per barcode.
